#ifndef __RT_TIME_H__
#define __RT_TIME_H__

#ifdef __KERNEL__
#include <linux/time.h>
extern int rt_latch2;
#endif

#define FREQ_8254 1193180

#define SHIFT_8254 7

#define RT_TIME_END 0x7fffFfffFfffFfffLL

typedef long long RTIME;

struct calibration_data {      int cpu_freq, 
				   latency,	
			           setup_time_8254CPU,
			           setup_time_8254;
			 long long oneshot_n2c, oneshot_c2n,
			           periodic_n2c, periodic_c2n; };

struct rt_times {  int linux_tick,
                       periodic_tick;
		 RTIME tick_time, 
		       linux_time,
		       intr_time,
		       time_mark; };

extern int rt_to_jiffie(void);

extern void rt_set_linux_timer_hook(void (*fun)(void));

extern void rt_get_tuned_data(int freq_cpu, struct calibration_data *tuned_data);

extern void rt_request_timer(void (*rt_timer_handler)(void), int tick, struct rt_times *times);

extern void rt_free_timer(void);

static inline unsigned long long rdtsc(void)
{
	union {unsigned long long time; unsigned long time_lh[2]; } tsc;
	__asm__ __volatile__( "rdtsc": "=a" (tsc.time_lh[0]), "=d" (tsc.time_lh[1]): :"ax", "dx");
	return tsc.time;
}

/*
static inline int imuldiv(int a, int mult, int div)
{
	__asm__("imull %1 ; idivl %2"
		:"=a" (a)
		:"d" (mult),
		 "r" (div),
		 "0" (a)
		:"dx");
	return a;
}
*/

static inline int imuldiv(int a, int mult, int div)
{
       __asm__("imull %1 ; movl %2,%%ecx; sar $1,%%ecx\n\t"
	       "addl %%ecx,%%eax; adc $0,%%edx; idivl %2"
               : "=a" (a)
               : "d" (mult),
                 "r" (div),
                 "0" (a)
               : "ax", "cx", "dx");
       return a;
}

static inline RTIME rt_ts_to_rtime(struct timespec *res)
{
	return res->tv_sec * FREQ_8254 + imuldiv(res->tv_nsec, FREQ_8254, 1000000000);
}

extern RTIME rt_get_prof_time(void);

#endif
